read("base.inc");

test_aceval := proc(f, path, prec, forcedeq:=`none`)
    local deq, rec, val, err;
    if forcedeq = `none` then
        deq := diffeqtohomdiffeq(holexprtodiffeq(f(z),y(z)),y(z));
    else
        deq := forcedeq;
    end if;
    rec := rectohomrec(diffeqtorec(deq,y(z),u(n)),u(n));
    val := ac_eval(deq,y(z),path,prec);
    err := evalf[prec*2](val - f(path[-1]));
    if err > 10^(-prec) then error "Incorrect result!" end if;
end proc;

trace(test_aceval);

trace(ac_eval);


